################################################################################
# stages for apq8096 projects in voxl-cross docker build environment
#
# Note you can combine these with qrb5165 stages for combined projects
# see: voxl-cross-template librc_math
################################################################################

################################################################################
# build and deploy to dev binary repo on every commit to dev
################################################################################

build_cross_apq8096_dev:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash ci-tools/scripts/check-build-deps-deb.sh apq8096 dev
    - /bin/bash ci-tools/scripts/check-build-script.sh apq8096
    - /bin/bash make_package.sh ipk
    - date
  artifacts:
    expire_in: 20 min
    paths:
      - "*.ipk"

deploy_cross_apq8096_dev:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_cross_apq8096_dev
  dependencies:
    - build_cross_apq8096_dev
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    PLATFORM: apq8096
  script:
    - /bin/bash ci-tools/scripts/deploy-deb-repo.sh
    - date


################################################################################
# build and deploy to public binary deb repo on tag
################################################################################

build_cross_apq8096_tag:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_COMMIT_BRANCH != "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash ci-tools/scripts/check-build-deps-deb.sh apq8096 $CI_COMMIT_TAG
    - /bin/bash ci-tools/scripts/check-build-script.sh apq8096
    - /bin/bash make_package.sh ipk
    - date
  artifacts:
    expire_in: 1 month
    paths:
      - "*.ipk"

deploy_cross_apq8096_tag:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_cross_apq8096_tag
  dependencies:
    - build_cross_apq8096_tag
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_COMMIT_BRANCH != "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    PLATFORM: apq8096
  script:
    - /bin/bash ci-tools/scripts/deploy-deb-repo.sh
    - date


################################################################################
# nightly builds on schedule for dev and default branches
################################################################################

nightly_cross_apq8096_dev:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE == "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash ci-tools/scripts/check-build-deps-deb.sh apq8096 dev
    - /bin/bash ci-tools/scripts/check-build-script.sh apq8096
    - /bin/bash make_package.sh ipk
    - date
  artifacts:
    expire_in: 20 min
    paths:
      - "*.ipk"

nightly_cross_apq8096_master:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && ($CI_PIPELINE_SOURCE == "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash ci-tools/scripts/check-build-deps-deb.sh apq8096 staging
    - /bin/bash ci-tools/scripts/check-build-script.sh apq8096
    - /bin/bash make_package.sh ipk
    - date
  artifacts:
    expire_in: 20 min
    paths:
      - "*.ipk"


################################################################################
# Build (but don't deploy) master on commit.
################################################################################

build_cross_apq8096_master:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_TAG == null) && ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash ci-tools/scripts/check-build-deps-deb.sh apq8096 staging
    - /bin/bash ci-tools/scripts/check-build-script.sh apq8096
    - /bin/bash make_package.sh ipk
    - date
  artifacts:
    expire_in: 1 week
    paths:
      - "*.ipk"


